/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PERIPRODUCAO                                             */
/* Tabela : PERIPRODUCAO                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 23/04/2007 - Ronald Reis                                                   */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PERIPRODUCAO
BEFORE INSERT OR UPDATE OR DELETE
ON PERIPRODUCAO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPERP := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDPERIPRODU,0) <> NVL(:NEW.CDPERIPRODU,0)) OR
         (NVL(:OLD.NMPERIPRODU,0) <> NVL(:NEW.NMPERIPRODU,0)) OR
         (NVL(:OLD.IDDIANUTILP,0) <> NVL(:NEW.IDDIANUTILP,0)) OR
         (NVL(:OLD.IDTIPODIAP,0) <> NVL(:NEW.IDTIPODIAP,0)) THEN
         :NEW.DTULTATUPERP := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PERIPRODUCAO', '', 'CDPERIPRODU='||:OLD.CDPERIPRODU||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PERIPRODUCAO MODIFY DTULTATUPERP DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_PERIPRODUCAO','4.11.134'); END;
/
