/* eslint-disable no-console */
/* eslint-disable */
import {
    IDictionary, Metadata, Http,
    Loader,
    IEventParam,
} from '@zeedhi/core';
import {
    LoadingService, DialogService, TextInput

} from '@zeedhi/common';

import { TekGrid } from '@zeedhi/teknisa-components-common';
import { Utilities } from '@/util/Utilities';

export class Fm00020000TipoSolicitacoesController {
    public rowDisabled: boolean = false;

    public addNewRow({ component }: IEventParam<TekGrid>) {
        const newId = 0;
        component.addNewRow({ NRTIPOSOLICITACAO: newId, IDPRIORIDADEPADR: '1', IDATIVO: 'S' }, 'start');
        setTimeout(() => {
            const nameInput = Metadata.getInstance<TextInput>(`NMTIPOSOLICITACAO_editable_${newId}`);
            nameInput.setFocus();
        }, 100);
        this.rowDisabled = true;
    }

    public canEditRow({ row }: any) {
      if(row['__added_row'] === undefined){
        this.rowDisabled = false;
      } 
    }

    // Inserir Tipo de Solicitação
    public insertRequestType({ component, event }: IEventParam<TekGrid>) {
        event?.preventDefault();
        if (Utilities.validateGrid(component)) {

            LoadingService.show();
            Http.post('/insertRequestType', {
                PARAMS: component.getEditedRows(),
            }).then((response: IDictionary) => {
                Metadata.getInstance<TekGrid>('tipo-solicitacoes-tek-grid').datasource.get();
                Utilities.showSuccessMessage();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
                component.cancelEditedRows();
            });
        }
    }

    public inativarTipoSolicitacoes({ event }: any) {
        Utilities.showConfirmDisabledMessage(event, 'Fm00020000SolicitacoesController.aposConfirmarInativar');
    }

    public aposConfirmarInativar() {
        const component = Metadata.getInstance<TekGrid>('tipo-solicitacoes-tek-grid');
        LoadingService.show();
        Http.post('/inativarTipoSolicitacao', {
            NRS: component.selectedRows.map((element: any) => element.NRTIPOSOLICITACAO),
        }).then(() => {
            component.datasource.get();
            Utilities.showSuccessMessage();
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            component.selectedRows = [];
            LoadingService.hide();
            DialogService.hide();
        });
    }
}
